#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "ftd2xx.h"
#include "gto2param.h"

int main(int argc, char *argv[]){
  FT_HANDLE ftHandle = NULL;
  FT_STATUS ftStatus;
  int numDevs, i;
  FT_PROGRAM_DATA ftData;
  char ManufacturerBuf[32];
  char ManufacturerIdBuf[16];
  char DescriptionBuf[64];
  char SerialNumberBuf[16];

  ftData.Signature1 = 0x00000000;
  ftData.Signature2 = 0xffffffff;
  ftData.Version = 0x00000005;
  ftData.Manufacturer = ManufacturerBuf;
  ftData.ManufacturerId = ManufacturerIdBuf;
  ftData.Description = DescriptionBuf;
  ftData.SerialNumber = SerialNumberBuf;
  ftStatus = FT_CreateDeviceInfoList((LPDWORD)&numDevs);

  for(i=0;i<numDevs;i++){
    ftHandle = NULL;
    ftStatus = FT_Open(i, &ftHandle);
    if (ftStatus != FT_OK) {
      continue;
    }
    
    printf("ft opend device:%d\n", i);
    
    ftStatus = FT_EE_Read(ftHandle, &ftData);
    if(ftStatus != FT_OK){
      printf(" no EEPROM, skip this device\n\n");
      continue;
    }else{
      printf("Signature1     : 0x%08x\n", ftData.Signature1);
      printf("Signature2     : 0x%08x\n", ftData.Signature2);
      printf("Manufacturer   : %s\n", ManufacturerBuf);
      printf("ManufacturerId : %s\n", ManufacturerIdBuf);
      printf("Description    : %s\n", DescriptionBuf);
      printf("SerialNumber   : %s\n", SerialNumberBuf);
      printf("Version        : %d\n", ftData.Version);
      
      if(ftData.Version != 3){
	printf("This device is not for GTO2 (skip)\n\n");
	continue;
      }
      
      FT_ResetDevice(ftHandle);
      printf("Device %d RESET\n", i);
    }
    if(ftHandle) FT_Close(ftHandle);
  }

  return 0;
}

  
