﻿#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ftd2xx.h"

int main(int argc, char *argv[]){
	FT_HANDLE ftHandle = NULL;
	FT_STATUS ftStatus;
	FILE* fd = NULL;

	int numDevs;
	int i;
	FT_DEVICE_LIST_INFO_NODE *devInfo;

	FT_PROGRAM_DATA ftData;
	char ManufacturerBuf[32];
	char ManufacturerIdBuf[16];
	char DescriptionBuf[64];
	char SerialNumberBuf[16];

	ftData.Signature1 = 0x00000000;
	ftData.Signature2 = 0xffffffff;
	ftData.Version = 0x00000005;
	ftData.Manufacturer = ManufacturerBuf;
	ftData.ManufacturerId = ManufacturerIdBuf;
	ftData.Description = DescriptionBuf;
	ftData.SerialNumber = SerialNumberBuf;


	fd = NULL;


	for(i=1;i<3;i++){
	  ftHandle = NULL;
	  ftStatus = FT_Open(i, &ftHandle);
	  if (ftStatus != FT_OK) {
	    continue;
	  }

	  printf("ft opend device:%d\n", i);
	  ftStatus = FT_EE_Read(ftHandle, &ftData);
	  if(ftStatus != FT_OK){
	    printf(" no EEPROM\n");
	  }else{
	    printf("0x%08x,\n", ftData.Signature1);			// Header - must be 0x00000000 
	    printf("0x%08x,\n", ftData.Signature2);			// Header - must be 0xffffffff
	    printf("0x%04x,\n", ftData.Version);				// Header - FT_PROGRAM_DATA version
		//			0 = original
		//			1 = FT2232 extensions
		//			2 = FT232R extensions
		//			3 = FT2232H extensions
		//			4 = FT4232H extensions
		//			5 = FT232H extensions

		printf("0x%04x,\n", ftData.VendorId);				// 0x0403
		printf("0x%04x,\n", ftData.ProductId);				// 0x6001
		printf("\"%s\",\n", ManufacturerBuf);			// "FTDI"
		printf("\"%s\",\n", ManufacturerIdBuf);		// "FT"
		printf("\"%s\",\n", DescriptionBuf);			// "USB HS Serial Converter"
		printf("\"%s\",\n", SerialNumberBuf);			// "FT000001" if fixed, or NULL
		printf("0x%04x,\n", ftData.MaxPower);				// 0 < MaxPower <= 500
		printf("0x%04x,\n", ftData.PnP);					// 0 = disabled, 1 = enabled
		printf("0x%04x,\n", ftData.SelfPowered);			// 0 = bus powered, 1 = self powered
		printf("0x%04x,\n", ftData.RemoteWakeup);			// 0 = not capable, 1 = capable
		//
		// Rev4 (FT232B) extensions
		//
		printf("%d,\n", ftData.Rev4);					// non-zero if Rev4 chip, zero otherwise
		printf("%d,\n", ftData.IsoIn);				// non-zero if in endpoint is isochronous
		printf("%d,\n", ftData.IsoOut);				// non-zero if out endpoint is isochronous
		printf("%d,\n", ftData.PullDownEnable);		// non-zero if pull down enabled
		printf("%d,\n", ftData.SerNumEnable);			// non-zero if serial number to be used
		printf("%d,\n", ftData.USBVersionEnable);		// non-zero if chip uses USBVersion
		printf("0x%04x,\n", ftData.USBVersion);			// BCD (0x0200 => USB2)
		//
		// Rev 5 (FT2232) extensions
		//
		printf("%d,\n", ftData.Rev5);					// non-zero if Rev5 chip, zero otherwise
		printf("%d,\n", ftData.IsoInA);				// non-zero if in endpoint is isochronous
		printf("%d,\n", ftData.IsoInB);				// non-zero if in endpoint is isochronous
		printf("%d,\n", ftData.IsoOutA);				// non-zero if out endpoint is isochronous
		printf("%d,\n", ftData.IsoOutB);				// non-zero if out endpoint is isochronous
		printf("%d,\n", ftData.PullDownEnable5);		// non-zero if pull down enabled
		printf("%d,\n", ftData.SerNumEnable5);		// non-zero if serial number to be used
		printf("%d,\n", ftData.USBVersionEnable5);	// non-zero if chip uses USBVersion
		printf("0x%04x,\n", ftData.USBVersion5);			// BCD (0x0200 => USB2)
		printf("%d,\n", ftData.AIsHighCurrent);		// non-zero if interface is high current
		printf("%d,\n", ftData.BIsHighCurrent);		// non-zero if interface is high current
		printf("%d,\n", ftData.IFAIsFifo);			// non-zero if interface is 245 FIFO
		printf("%d,\n", ftData.IFAIsFifoTar);			// non-zero if interface is 245 FIFO CPU target
		printf("%d,\n", ftData.IFAIsFastSer);			// non-zero if interface is Fast serial
		printf("%d,\n", ftData.AIsVCP);				// non-zero if interface is to use VCP drivers
		printf("%d,\n", ftData.IFBIsFifo);			// non-zero if interface is 245 FIFO
		printf("%d,\n", ftData.IFBIsFifoTar);			// non-zero if interface is 245 FIFO CPU target
		printf("%d,\n", ftData.IFBIsFastSer);			// non-zero if interface is Fast serial
		printf("%d,\n", ftData.BIsVCP);				// non-zero if interface is to use VCP drivers
		//
		// Rev 6 (FT232R) extensions
		//
		printf("%d,\n", ftData.UseExtOsc);			// Use External Oscillator
		printf("%d,\n", ftData.HighDriveIOs);			// High Drive I/Os
		printf("%d,\n", ftData.EndpointSize);			// Endpoint size
		printf("%d,\n", ftData.PullDownEnableR);		// non-zero if pull down enabled
		printf("%d,\n", ftData.SerNumEnableR);		// non-zero if serial number to be used
		printf("%d,\n", ftData.InvertTXD);			// non-zero if invert TXD
		printf("%d,\n", ftData.InvertRXD);			// non-zero if invert RXD
		printf("%d,\n", ftData.InvertRTS);			// non-zero if invert RTS
		printf("%d,\n", ftData.InvertCTS);			// non-zero if invert CTS
		printf("%d,\n", ftData.InvertDTR);			// non-zero if invert DTR
		printf("%d,\n", ftData.InvertDSR);			// non-zero if invert DSR
		printf("%d,\n", ftData.InvertDCD);			// non-zero if invert DCD
		printf("%d,\n", ftData.InvertRI);				// non-zero if invert RI
		printf("%d,\n", ftData.Cbus0);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus1);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus2);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus3);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus4);				// Cbus Mux control
		printf("%d,\n", ftData.RIsD2XX);				// non-zero if using D2XX driver
		//
		// Rev 7 (FT2232H) Extensions
		//
		printf("%d,\n", ftData.PullDownEnable7);		// non-zero if pull down enabled
		printf("%d,\n", ftData.SerNumEnable7);		// non-zero if serial number to be used
		printf("%d,\n", ftData.ALSlowSlew);			// non-zero if AL pins have slow slew
		printf("%d,\n", ftData.ALSchmittInput);		// non-zero if AL pins are Schmitt input
		printf("%d,\n", ftData.ALDriveCurrent);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.AHSlowSlew);			// non-zero if AH pins have slow slew
		printf("%d,\n", ftData.AHSchmittInput);		// non-zero if AH pins are Schmitt input
		printf("%d,\n", ftData.AHDriveCurrent);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.BLSlowSlew);			// non-zero if BL pins have slow slew
		printf("%d,\n", ftData.BLSchmittInput);		// non-zero if BL pins are Schmitt input
		printf("%d,\n", ftData.BLDriveCurrent);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.BHSlowSlew);			// non-zero if BH pins have slow slew
		printf("%d,\n", ftData.BHSchmittInput);		// non-zero if BH pins are Schmitt input
		printf("%d,\n", ftData.BHDriveCurrent);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.IFAIsFifo7);			// non-zero if interface is 245 FIFO
		printf("%d,\n", ftData.IFAIsFifoTar7);		// non-zero if interface is 245 FIFO CPU target
		printf("%d,\n", ftData.IFAIsFastSer7);		// non-zero if interface is Fast serial
		printf("%d,\n", ftData.AIsVCP7);				// non-zero if interface is to use VCP drivers
		printf("%d,\n", ftData.IFBIsFifo7);			// non-zero if interface is 245 FIFO
		printf("%d,\n", ftData.IFBIsFifoTar7);		// non-zero if interface is 245 FIFO CPU target
		printf("%d,\n", ftData.IFBIsFastSer7);		// non-zero if interface is Fast serial
		printf("%d,\n", ftData.BIsVCP7);				// non-zero if interface is to use VCP drivers
		printf("%d,\n", ftData.PowerSaveEnable);		// non-zero if using BCBUS7 to save power for self-powered designs
		//
		// Rev 8 (FT4232H) Extensions
		//
		printf("%d,\n", ftData.PullDownEnable8);		// non-zero if pull down enabled
		printf("%d,\n", ftData.SerNumEnable8);		// non-zero if serial number to be used
		printf("%d,\n", ftData.ASlowSlew);			// non-zero if A pins have slow slew
		printf("%d,\n", ftData.ASchmittInput);		// non-zero if A pins are Schmitt input
		printf("%d,\n", ftData.ADriveCurrent);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.BSlowSlew);			// non-zero if B pins have slow slew
		printf("%d,\n", ftData.BSchmittInput);		// non-zero if B pins are Schmitt input
		printf("%d,\n", ftData.BDriveCurrent);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.CSlowSlew);			// non-zero if C pins have slow slew
		printf("%d,\n", ftData.CSchmittInput);		// non-zero if C pins are Schmitt input
		printf("%d,\n", ftData.CDriveCurrent);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.DSlowSlew);			// non-zero if D pins have slow slew
		printf("%d,\n", ftData.DSchmittInput);		// non-zero if D pins are Schmitt input
		printf("%d,\n", ftData.DDriveCurrent);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.ARIIsTXDEN);			// non-zero if port A uses RI as RS485 TXDEN
		printf("%d,\n", ftData.BRIIsTXDEN);			// non-zero if port B uses RI as RS485 TXDEN
		printf("%d,\n", ftData.CRIIsTXDEN);			// non-zero if port C uses RI as RS485 TXDEN
		printf("%d,\n", ftData.DRIIsTXDEN);			// non-zero if port D uses RI as RS485 TXDEN
		printf("%d,\n", ftData.AIsVCP8);				// non-zero if interface is to use VCP drivers
		printf("%d,\n", ftData.BIsVCP8);				// non-zero if interface is to use VCP drivers
		printf("%d,\n", ftData.CIsVCP8);				// non-zero if interface is to use VCP drivers
		printf("%d,\n", ftData.DIsVCP8);				// non-zero if interface is to use VCP drivers
		//
		// Rev 9 (FT232H) Extensions
		//
		printf("%d,\n", ftData.PullDownEnableH);		// non-zero if pull down enabled
		printf("%d,\n", ftData.SerNumEnableH);		// non-zero if serial number to be used
		printf("%d,\n", ftData.ACSlowSlewH);			// non-zero if AC pins have slow slew
		printf("%d,\n", ftData.ACSchmittInputH);		// non-zero if AC pins are Schmitt input
		printf("%d,\n", ftData.ACDriveCurrentH);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.ADSlowSlewH);			// non-zero if AD pins have slow slew
		printf("%d,\n", ftData.ADSchmittInputH);		// non-zero if AD pins are Schmitt input
		printf("%d,\n", ftData.ADDriveCurrentH);		// valid values are 4mA, 8mA, 12mA, 16mA
		printf("%d,\n", ftData.Cbus0H);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus1H);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus2H);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus3H);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus4H);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus5H);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus6H);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus7H);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus8H);				// Cbus Mux control
		printf("%d,\n", ftData.Cbus9H);				// Cbus Mux control
		printf("%d,\n", ftData.IsFifoH);				// non-zero if interface is 245 FIFO
		printf("%d,\n", ftData.IsFifoTarH);			// non-zero if interface is 245 FIFO CPU target
		printf("%d,\n", ftData.IsFastSerH);			// non-zero if interface is Fast serial
		printf("%d,\n", ftData.IsFT1248H);			// non-zero if interface is FT1248
		printf("%d,\n", ftData.FT1248CpolH);			// FT1248 clock polarity - clock idle high (1) or clock idle low (0)
		printf("%d,\n", ftData.FT1248LsbH);			// FT1248 data is LSB (1) or MSB (0)
		printf("%d,\n", ftData.FT1248FlowControlH);	// FT1248 flow control enable
		printf("%d,\n", ftData.IsVCPH);				// non-zero if interface is to use VCP drivers
		printf("%d,\n", ftData.PowerSaveEnableH);		// non-zero if using ACBUS7 to save power for self-powered designs
		
	  }
	  
	  
	  if (ftHandle != NULL) {
	    FT_Close(ftHandle);
	  }
	}




	return 0;
}

